; main.asm
extern fopen
extern fprintf
extern fclose
extern	printf


extern PerimeterRectangle
extern PerimeterTriangle
extern PerimeterShape
extern PerimeterSumContainer

extern OutRectangle
extern OutTriangle
extern OutShape
extern OutContainer

global RECTANGLE
global TRIANGLE

section .data
    testFileOut     dq  "testFileOut.txt",0  ; имя тестового файла для записи
    toWrite         db  "w"

    outfmt db "It is Rectangle: x = %d, y = %d. Perimeter = %g",10,0
    ;outfmt db "It is Rectangle: x = %d, y = %d",10,0
    pfmt    db      "Perimeter = %d, %f",10,0 ; printf format
    pcfmt   db      "Common Perimeter = %f",10,0 ; printf format
    RECTANGLE   dd  1
    TRIANGLE    dd  2
    shapeRect   dd  1
    rect    dd      5,7     ; прямоугольник с двумя сторонами
    empty   dd      0       ; пустое слово в фигуре для прямоугольника
    shapeTrian  dd  2
    trian   dd      3,4,5   ; три стороны треугольника
    ; Массив фигур
    cont    dd      1,2,3,0, 2,3,4,5, 1,2,8,0, 2,2,2,2, 2,5,7,4, 1,5,6,0
    len     dd      6
section .bss
    FILE    resq    1       ; Указатель на FILE
    p       resq    1       ; периметр как действительное
    y       resq    1
section .text
    global main
;----------------------------------------------
main:
    push    rbp
    mov     rbp,rsp

    ; Открытие файла для записи фигур
    mov     rdi, testFileOut    ; имя открываемого файла
    lea     rsi, toWrite        ; открыть для записи
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    fopen
    mov     [FILE], rax         ; сохранение указателя на файл

    ; Вывод параметров прямоугольника
    mov     rdi, rect
    mov     rsi, [FILE]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    OutRectangle

    ; Вывод параметров треугольника
    mov     rdi, trian
    mov     rsi, [FILE]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    OutTriangle

    ; Вывод параметров фигуры-прямоугольника
    mov     rdi, shapeRect
    mov     rsi, [FILE]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    OutShape

    ; Вывод параметров фигуры-треугольника
    mov     rdi, shapeTrian
    mov     rsi, [FILE]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    OutShape

    ; Вывод 2-х фигур
    mov     rdi, shapeRect
    mov     rsi, 2
    mov     rdx, [FILE]
    call    OutContainer

    ; Вывод нескольких фигур
    mov     rdi, cont
    mov     rsi, [len]
    mov     rdx, [FILE]
    call    OutContainer

    mov     rdi, [FILE]         ; передача указателя на закрываемый файл
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    fclose

    pop     rbp
    mov     rax,60
    mov     rdi,0
syscall
